"""Functions for getting the config used for compiling BOUT++

"""
# Created by cmake
_yesno = {"TRUE": True, "ON": True, "FALSE": False, "OFF": False}

config = {
    "cc": "/usr/lib64/mpich/bin/mpicc",
    "cxx": "/usr/lib64/mpich/bin/mpicxx",
    "ld": "/usr/lib64/mpich/bin/mpicxx",
    "checks": "2",
    "cflags": " -I${BOUT_INCLUDE_PATH}  -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-U_FORTIFY_SOURCE,-D_FORTIFY_SOURCE=3 -Wp,-D_GLIBCXX_ASSERTIONS -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -fstack-protector-strong -specs=/usr/lib/rpm/redhat/redhat-annobin-cc1  -m64 -march=z13 -mtune=z14 -fasynchronous-unwind-tables -fstack-clash-protection -I/usr/include/mpich-s390x/petsc",
    "libs": "",
    "version": "5.2.0",
    "git": "Unknown",
    "idlpath": "",
    "pythonpath": "/usr//usr/lib64/python3.12/site-packages/mpich",
    "has_netcdf": "ON",
    "has_legacy_netcdf": "OFF",
    "has_pnetcdf": "OFF",
    "has_pvode": "ON",
    "has_cvode": "ON",
    "has_ida": "ON",
    "has_lapack": "TRUE",
    "has_petsc": "ON",
    "has_slepc": "OFF",
    "has_mumps": "OFF",
    "has_arkode": "ON",
    "has_openmp": "OFF",
    "has_nls": "ON",
    "has_fftw": "ON",
    "petsc_has_sundials": "",
    "metric_type": "2D",
}

for k, v in config.items():
    config[k] = (
        v.replace(
            "${BOUT_INCLUDE_PATH}", "/usr//usr/include/mpich-s390x/bout++"
        )
        .replace(
            "${MPARK_VARIANT_INCLUDE_PATH}", "/usr/include"
        )
        .replace(
            "${FMT_INCLUDE_PATH}", "/usr/include"
        )
    )


"""Get a dict of the enabled features"""
has = {}
for k in config:
    if k.startswith("has_"):
        has[k[4:]] = _yesno[config[k]]


def isMetric2D():
    """Is the metric 2D?"""
    return config["metric_type"] == "2D"


def isMetric3D():
    """Is the metric 3D?"""
    return config["metric_type"] == "3D"
